class FlagTracker expands Mutator;

#exec obj load file=..\System\CTFRCBeacon.u package=CTFRCBeacon

var color clMsg;
var CTFGame CTF;
var bool bDisabled;
var const string version;
var name Ttag;

event PostBeginPlay()
{
	local NavigationPoint N;
	local int NumP;

	if ( Level.Game != None )
		Level.Game.RegisterMessageMutator(Self);
	log ( Self.Class@"version"@version@"is being loaded..." );
	if ( CTFGame(Level.Game) != None )
	{
		Ttag='CTFway';
		CTF = CTFGame(Level.Game);
		log ( Self.Name@"has found Capture The Flag game-type loaded.",'FlagTracker');
		foreach AllActors (class 'NavigationPoint', N)
			NumP++;
		if ( NumP < 5 )
		{
			log ("This Level doesn't seems too rich in paths."@Self.Name@"will go disabled...");
			bDisabled = True;
		}
	}
	else
	{
		log ("This game-type is not an Original CTFGame."@Self.Name@"will not run on demand...");
		bDisabled=True;
	}
}

function ModifyPlayer(Pawn Other)
{
	local CTFWay W;
	local bool bHasBeacon;

	Super.ModifyPlayer(Other);

	if ( !bDisabled )
	if ( TournamentPlayer(Other) != None )
	{
		foreach Other.ChildActors(class'CTFWay',W)
		{
			bHasBeacon=True;
			break;
		}
		if (!bHasBeacon)
		{
			W = Spawn(class'CTFWay',Other,,Other.Location);
			log ("A Path Identifier has been spawned for"@Other.GetHumanName());
		}
	}
}


function Mutate(string MutateString, PlayerPawn Sender)
{
	local CTFWay W;
	local bool bAbusing, bFoundTarget, bHasATarget, bWayPoint, bFoundEnemyFlag;
	local CTFFlag AFlag;
	local Actor Path, TheGoal, ATarget;
	local float BestWeight;
	local AltTarget At;
	local int i;

	Super.Mutate(MutateString, Sender);
	if ( Caps(MutateString) ~= "HELPME" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("CTFFlagTracker"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		Sender.ClientMessage("CTFFlagTracker debugger available commands (Open Console for full view or see log file):");
		Sender.ClientMessage("[mutate mytarget] - spawn a Target-Beacon that can be found later until you die.");
		Sender.ClientMessage("[mutate mypath] - find path to Target-Beacon if it's unreachable directly but available through navigation.");
		Sender.ClientMessage("[mutate mebot] - attempt to track needed CTF flag - mapped routes if available.");
		Sender.ClientMessage("[mutate stopnav] - stops searching paths - it will be almost deactivated.");
//---------------------
		log("[mutate mytarget] - spawn a Target-Beacon that can be found later until you die.");
		log("[mutate mypath] - find path to Target-Beacon if available and/or Unreachable.");
		log("[mutate mebot] - attempt to track CTF A.I. mapped routes if available.");
		log("[mutate stopnav] - stops searching paths - it will be almost deactivated.");
		GoTo NoMoreAction;
	}

/*
	if ( Caps(MutateString) ~= "VISIBLESTUFF" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("MHBotyMan"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		foreach AllActors (class 'MonsterWayPoint',AFlag)
		{
			if ( AFlag.bHidden )
				AFlag.bHidden = False;
		}
		foreach AllActors (class 'MonsterEnd',M)
		{
			if (M.bHidden)
				M.bHidden = False;
		}
		Sender.ClientMessage("MonsterHunt BotyMan"$version$" has received Request for Visible MH A.I. Stuff...");
	}

	if ( Caps(MutateString) ~= "HIDESTUFF" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("MHBotyMan"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		foreach AllActors (class 'MonsterWayPoint',AFlag)
		{
			if ( !AFlag.bHidden )
				AFlag.bHidden = True;
		}
		foreach AllActors (class 'MonsterEnd',M)
		{
			if (!M.bHidden)
				M.bHidden = True;
		}
		Sender.ClientMessage("MonsterHunt BotyMan"$version$" has received Request for Invisible MH A.I. Stuff...");
	}
*/

	if ( Caps(MutateString) ~= "STOPNAV" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("CTFFlagTracker"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		Foreach AllActors (Class 'CTFWay',W,Ttag)
		{
			if ( W.Owner == Sender )
			{
				W.bWorking = False;
				break;
			}
		}
		Sender.ClearProgressMessages();
		Sender.SetProgressMessage("Navigation has been turned off.",1);
		clMsg.R=255;
		clMsg.G=255;
		clMsg.B=120;
		Sender.SetProgressColor(clMsg,1);
		Sender.SetProgressTime(8);
	}

	if ( Caps(MutateString) ~= "MYTARGET" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("CTFFlagTracker"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		Foreach Sender.ChildActors(class'AltTarget',At)
		{
			ATarget=At;
			bHasATarget=True;
			break;
		}
		if ( bHasATarget )
		{
			ATarget.SetLocation(Sender.Location);
			if ( ATarget != None )
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Your Target has been Moved at your current location... Step aside and check it.",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(8);
			}
			else
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("BORK >>> Your Target has been eliminated...",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
			}
		}
		else
		{
			At=spawn(class'AltTarget',Sender,,Sender.Location);
			if ( At != None )
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Your Target has been Created at this location... Step away and see it. You can use [mutate mypath] for finding it.",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(8);
			}
			else
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Your Target could not spawn at your current location... Step aside and retry.",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(8);
			}
		}
	}

	if ( Caps(MutateString) ~= "MYPATH" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("CTFFlagTracker"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		if ( Sender.Health < 1 )
		{
			Sender.ClientPlaySound(Sound'UnrealShare.BreakGlass');
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("No Shit, what's next!? Return to life first, dead pawn won't roam...",1);
			clMsg.R=255;
			clMsg.G=255;
			clMsg.B=120;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			GoTo NoMoreAction;
		}
		Foreach Sender.ChildActors(class'AltTarget',At)
		{
			bHasATarget=True;
			ATarget=At;
			break;
		}
		if ( bHasATarget )
		{
			Sender.Destination = ATarget.Location;
			if (Sender.ActorReachable(ATarget))
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Destination Point is Reachable...",1);
				clMsg.R=200;
				clMsg.G=200;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
			}
			else
			{
				Path = Sender.FindPathToward(ATarget);
				if ( Path != None )
				{
					Foreach AllActors (class 'CTFWay', W)
					{
						if (W.Owner == Sender)
						{
							W.TheGoal=ATarget;
							W.bWorking=True;
						}
					}
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Target-Way Navigation >> Look for the Red Circles and follow them...",1);
					clMsg.R=0;
					clMsg.G=255;
					clMsg.B=64;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
				}
				else
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Unable to find your Monster way. Wander at walls then...",1);
					clMsg.R=250;
					clMsg.G=0;
					clMsg.B=0;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
				}
			}
		}
		else
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Unable to find your Monster way. Use [mutate mytarget] command for placing a destination point.",1);
			clMsg.R=250;
			clMsg.G=0;
			clMsg.B=0;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
		}
	}

	if ( Caps(MutateString) ~= "MEBOT" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("CTFFlagTracker"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		if ( Sender.Health < 1 )
		{
			Sender.ClientPlaySound(Sound'UnrealShare.BreakGlass');
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("No Shit, what's next!? Return to life first, dead pawn won't roam...",1);
			clMsg.R=255;
			clMsg.G=255;
			clMsg.B=120;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			GoTo NoMoreAction;
		}
		clMsg.R=100;
		clMsg.G=100;
		clMsg.B=100;
		foreach AllActors (class 'CTFFlag',AFlag)
		{
			if ( AFlag.Team == Sender.PlayerReplicationInfo.Team )
			{
				if ( !AFlag.bHome )
				{
					bWayPoint=True;
					TheGoal = AFlag.Position();
					Sender.Destination = AFlag.Position().Location;
					Sender.ClientMessage("Found"@AFlag.Name@" out of HomeBase - must recover it >> perform Route Test...");
					if ( Sender.ActorReachable(TheGoal) )
					{
						bFoundTarget=True;
						break;
					}
					else if (Sender.FindPathToward(TheGoal) != None)
					{
						bFoundTarget=True;
						break;
					}
					else
					{
						Sender.bHunting = True;
						if ( Sender.FindPathToward(TheGoal) != None )
						{
							bFoundTarget = True;
							break;
						}
					}
					if (!bFoundTarget)
					{
						BroadcastMessage("No Valid route for Flag has been found... but we activate Navigation Mode.");
						foreach AllActors (class 'CTFWay',W)
						{
							if ( W.Owner == Sender )
							{
								W.TheGoal = TheGoal;
								W.bWorking = True;
							}
						}
					}
					break;
				}
			}
			else
			{
				if ( AFlag.bHome )
					TheGoal=AFlag;
				else
					TheGoal=AFlag.Position();
				if ( Sender.ActorReachable(TheGoal) )
				{
					bFoundEnemyFlag = True;
					break;
				}
				else if (Sender.FindPathToward(TheGoal) != None)
				{
					bFoundEnemyFlag = True;
					break;
				}
				else
				{
					Sender.bHunting = True;
					if (Sender.FindPathToward(TheGoal) != None)
					{
						bFoundEnemyFlag=True;
						break;
					}
				}
				if ( !bFoundEnemyFlag )
				{
					BroadcastMessage("No Valid route for Flag has been found... but we activate Navigation Mode.");
					foreach AllActors (class 'CTFWay',W)
					{
						if ( W.Owner == Sender )
						{
							W.TheGoal = TheGoal;
							W.bWorking = True;
						}
					}
				}
			}
		}
// What if conditions go bellow
		if ( bWayPoint )
		{
		if ( bFoundTarget )
		{
			Sender.Destination = TheGoal.Location;
			Sender.ClientMessage("Your Destination is"@TheGoal@"from location >>"@TheGoal.Location);
			if ( Sender.ActorReachable(TheGoal))
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Destination Flag is Reachable... Hurry up, recover it.",1);
				clMsg.R=200;
				clMsg.G=200;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
			}
			else
			{
				if ( VSize(Sender.Location - TheGoal.Location) < 512 && FastTrace(Sender.Location,TheGoal.Location ))
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Destination Flag is Visible but not Reachable... Try to recover it.",1);
					clMsg.R=200;
					clMsg.G=200;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
				}
				Sender.bHunting = False;
				Path = Sender.FindPathToward(TheGoal);
				if ( Path != None )
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Way to your Flag will be shown. Look for the Way Beacons and follow them... Recover Flag.",1);
					clMsg.R=0;
					clMsg.G=255;
					clMsg.B=64;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
				}
				else
				{
					Sender.bHunting=True;
					Path = Sender.FindPathToward(TheGoal);
					if ( Path != None )
					{
						Sender.ClearProgressMessages();
						Sender.SetProgressMessage("The way to your Flag will be shown in Hunting Mode. This is not original CTFGame and UT Bot strategy... You have to recover Flag.",1);
						clMsg.R=0;
						clMsg.G=255;
						clMsg.B=64;
						Sender.SetProgressColor(clMsg,1);
						Sender.SetProgressTime(5);
						Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
						Sender.bHunting=False;
					}
				}
			}
			foreach AllActors (class 'CTFWay',W)
			{
				if ( W.Owner == Sender )
				{
					W.TheGoal = TheGoal;
					W.bWorking = True;
				}
			}
			return;
		}
		else
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Cannot Find A Route right now. Check paths...",1);
			clMsg.R=240;
			clMsg.G=0;
			clMsg.B=0;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(5);
			Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
		}
		GoTo NoMoreAction;
		}
		if ( bFoundEnemyFlag )
		{
			Sender.Destination = TheGoal.Location;
			Sender.ClientMessage("Your Destination is"@TheGoal@"from location >>"@TheGoal.Location);
			if ( Sender.ActorReachable(TheGoal))
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Destination Flag is Reachable... Go get it.",1);
				clMsg.R=200;
				clMsg.G=200;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
			}
			else
			{
				if ( VSize(Sender.Location - TheGoal.Location) < 512 && FastTrace(Sender.Location,TheGoal.Location ))
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Destination Flag is Visible but not Reachable... Try to get it.",1);
					clMsg.R=200;
					clMsg.G=200;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
				}
				Sender.bHunting = False;
				Path = Sender.FindPathToward(TheGoal);
				if ( Path != None )
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Way to Enemy Flag will be shown. Look for the Way Beacons and follow them... Take their Flag.",1);
					clMsg.R=0;
					clMsg.G=255;
					clMsg.B=64;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
				}
				else
				{
					Sender.bHunting=True;
					Path = Sender.FindPathToward(TheGoal);
					if ( Path != None )
					{
						Sender.ClearProgressMessages();
						Sender.SetProgressMessage("The way to Enemy Flag will be shown in Hunting Mode. This is not original CTFGame and UT Bot strategy... You have to recover Flag.",1);
						clMsg.R=0;
						clMsg.G=255;
						clMsg.B=64;
						Sender.SetProgressColor(clMsg,1);
						Sender.SetProgressTime(5);
						Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
						Sender.bHunting=False;
					}
				}
			}
			foreach AllActors (class 'CTFWay',W)
			{
				if ( W.Owner == Sender )
				{
					W.TheGoal = TheGoal;
					W.bWorking = True;
				}
			}
			GoTo NoMoreAction;
		}
		else
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Cannot Find A Route To Enemy Flag right now. Check paths...",1);
			clMsg.R=240;
			clMsg.G=0;
			clMsg.B=0;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(5);
			Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
		}
	}
NoMoreAction:
	TheGoal = None;
	Path = None;
}

DefaultProperties
{
	version="1.00"
}